
from optparse import OptionParser
import os


LAUNCH_AGENT_DIR = os.path.expanduser("~/Library/LaunchAgents/")
SCRIPT_DIR = os.path.expanduser("~/Library/Application Support/Growl/")
LOG_DIR = os.path.expanduser("~/Library/Logs/")

LAUNCH_AGENT_PATH = os.path.expanduser(LAUNCH_AGENT_DIR + "com.nirmalpatel.GrowlToNotifo.plist")
SCRIPT_PATH = os.path.expanduser(SCRIPT_DIR + "growlToNotifo.py")
LOG_PATH = os.path.expanduser(LOG_DIR + "GrowlToNotifo.log")


def checkForAndCreateDirs():
    
    if (not os.access(LAUNCH_AGENT_DIR, os.F_OK)):
        try:
            os.mkdir(LAUNCH_AGENT_DIR)
            print "Missing %s ... created"
        except:
            print "ERROR creating %s"
            
    if (not os.access(SCRIPT_DIR, os.F_OK)):
        try:
            os.mkdir(LAUNCH_AGENT_DIR)
            print "Missing %s ... created"
        except:
            print "ERROR creating %s"


    if (not os.access(LOG_DIR, os.F_OK)):
        try:
            os.mkdir(LAUNCH_AGENT_DIR)
            print "Missing %s ... created"
        except:
            print "ERROR creating %s"




def setupScript(username, apiSecret):
    usernameString = "NOTIFO_USERNAME = '%s'" % username
    apiSecretString = "NOTIFO_API_SECRET = '%s'" % apiSecret
    
    baseCodeFile = open("growlToNotifo.py")
    baseCode = baseCodeFile.read()
    baseCodeFile.close()

    code = "\n".join([usernameString, apiSecretString, baseCode])
    
    codeFile = open(SCRIPT_PATH, "w")
    codeFile.write(code)
    codeFile.close()


def setupLogging():
    os.system("touch %s" % LOG_PATH)
    os.system("defaults write com.Growl.GrowlHelperApp GrowlLoggingEnabled -bool YES")
    os.system("defaults write com.Growl.GrowlHelperApp GrowlLogType 1")
    os.system('defaults write com.Growl.GrowlHelperApp "Custom log history 1" %s' % LOG_PATH)


def setupLaunchAgent():
    launchAgentFile = open("com.nirmalpatel.GrowlToNotifo.plist")
    launchAgentData = launchAgentFile.read()
    launchAgentFile.close()
    
    launchAgentFile = open(LAUNCH_AGENT_PATH, "w")
    launchAgentFile.write(launchAgentData)
    launchAgentFile.close()
    
    os.system("launchctl load %s" % LAUNCH_AGENT_PATH)


def setup(username, apiSecret):
    
    checkForAndCreateDirs()
    setupScript(username, apiSecret)
    setupLogging()
    setupLaunchAgent()
    

def uninstall():
    os.system("launchctl unload %s" % LAUNCH_AGENT_PATH)
    os.system("defaults write com.Growl.GrowlHelperApp GrowlLoggingEnabled -bool NO")

    os.remove(LAUNCH_AGENT_PATH)
    os.remove(SCRIPT_PATH)
    os.remove(LOG_PATH)
    
    
def main():

    usage = "usage: %prog [options] arg"
    parser = OptionParser(usage)
    parser.add_option("-u", dest="username",
                      help="Notifo username")
    parser.add_option("-p", dest="apiSecret", 
                      help="Notifo API Secret")
    parser.add_option("--uninstall", action="store_true",
                      help="Disable Growl logging and remove installed files")
    (options, args) = parser.parse_args()
    
    if (options.uninstall):
        uninstall()
    elif (not (options.username and options.apiSecret)):
        parser.error('use the "--help" option to understand usage\n')
    else:
        setup(options.username, options.apiSecret)
        print "Please stop and start Growl from the Growl Preference Pane to complete installation."
    
if __name__ == "__main__":
    main()
